<template>
    <section class="contact-us">
        <div class="container">
            <div class="form-wrap">
                <div class="title" id="contact-us">
                    Contact Us
                </div>
                <ValidationObserver v-slot="{ handleSubmit }" ref="form">
                    <form @submit.prevent="handleSubmit(submitForm())">
                        <div class="form-group" :class="{
                                'focus': focusSelect,
                                'selected': form.interest.length,
                                'invalid': submit && !form.interest.length
                            }">
                            <v-select
                                    v-model="form.interest"
                                    :components="{OpenIndicator}"
                                    class="style-chooser"
                                    :searchable="false"
                                    :clearable="false"
                                    :options="interestOptions"
                                    @search:focus="onSelectFocus"
                                    @search:blur="onSelectBlur"
                            >
                            </v-select>
                            <label class="required">Interested in</label>
                        </div>
                        <ValidationProvider class="form-group" name="Name" rules="required" v-slot="{ errors }">
                            <input v-model="form.name" type="text" id="name"
                                   :class="{'invalid': errors.length}"
                                   v-typed/>
                            <label for="name" class="required">Your Name</label>
                        </ValidationProvider>
                        <ValidationProvider class="form-group" name="Email" rules="required|email"
                                            v-slot="{ errors }">
                            <input v-model="form.email" type="text" id="email"
                                   :class="{'invalid': errors.length}"
                                   v-typed/>
                            <label for="email" class="required">Email</label>
                        </ValidationProvider>
                        <div class="form-group textarea">
                            <textarea-autosize
                                    id="message"
                                    ref="myTextarea"
                                    v-model="form.message"
                                    :min-height="40"
                                    :max-height="71"
                                    v-typed
                                    maxlength="140"
                            />
                            <label for="message">Message</label>
                            <div class="maxlength"><span>{{form.message.length}}</span> / 140</div>
                        </div>

                        <button type="submit" v-ripple="'rgba(84, 149, 255, 0.35)'">Submit</button>
                        <div class="required-message">Please fill all the required fields</div>
                    </form>
                </ValidationObserver>
            </div>
        </div>
    </section>
</template>

<script>
    import vSelect from "vue-select";
    import '../../assets/styles/select.scss';
    import {ValidationObserver, ValidationProvider, extend} from 'vee-validate';
    import {required, email} from 'vee-validate/dist/rules';

    extend('email', email);
    extend('required', {
        ...required
    });

    export default {
        name: "ContactUs",
        components: {
            vSelect,
            ValidationProvider,
            ValidationObserver
        },
        data: () => {
            return {
                interestOptions: ['Starter Plan', 'Super Plan', 'Advanced Plan', 'Pro Plan', 'Other Questions'],
                textareaHeight: 40,
                focusSelect: false,
                submit: false,
                form: {
                    interest: '',
                    name: '',
                    email: '',
                    message: ''
                },
                OpenIndicator: {
                    render: createElement => createElement('img', {attrs: {src: require('../../assets/img/icons/arrow-select.svg')}}),
                },
            }
        },
        methods: {
            onSelectFocus() {
                this.focusSelect = true;
            },
            onSelectBlur() {
                this.focusSelect = false;
                this.submit = true;
            },
            submitForm: function () {
                this.submit = true;
                this.$refs.form.validate().then(success => {
                    if (!success) {
                        return;
                    }
                    this.$http.post(process.env.VUE_APP_ENDPOINT, {...this.form}).then((resp) => {
                        console.log(resp)
                    })
                    this.$nextTick(() => {
                        this.$refs.form.reset();
                    });
                });
            }
        },
        directives: {
            typed: {
                update: function (el) {
                    el.value.trim().length ? el.classList.add('not-empty') : el.classList.remove('not-empty')
                }
            }
        }
    }
</script>

<style scoped lang="scss">
    .contact-us {
        display: flex;
        justify-content: center;

        .container {
            position: relative;
            width: 998px;
            height: 772px;
            box-shadow: 0 24px 56px rgba(186, 195, 205, 0.58);
            border-radius: 2px;

            &:before {
                position: absolute;
                top: -25px;
                left: 94px;
                display: block;
                content: url("../../assets/img/backgrounds/contact-bg.svg");
            }

            .form-wrap {
                position: relative;
                width: 100%;
                height: 100%;
                background-color: #0263ff;
                z-index: 2;
                padding-top: 125px;
                box-sizing: border-box;

                .title {
                    color: #ffffff;
                    font-family: $mainFont, sans-serif;
                    font-size: 36px;
                    font-weight: 700;
                    letter-spacing: 0.8px;
                    text-align: center;
                }

                form {
                    display: block;
                    width: 468px;
                    margin: 80px auto 0 auto;

                    .form-group {
                        position: relative;
                        margin-top: 32px;
                        display: block;

                        &.invalid::v-deep {
                            .vs__dropdown-toggle {
                                background: rgba(#FF0000, .26);
                                border-color: #FF0000;
                            }
                        }


                        & > input {
                            @include inputStyle(#ffffff, #ffffff, rgba(#FF0000, .26), #FF0000, #0263ff);
                            height: 40px;
                        }

                        textarea {
                            @include inputStyle(#ffffff, #ffffff, rgba(#FF0000, .26), #FF0000, #0263ff);
                            box-sizing: border-box;
                            line-height: 24px;
                            height: 44px;

                            padding-right: 45px;
                        }

                        input:focus ~ label,
                        input.not-empty ~ label,
                        textarea:focus ~ label,
                        textarea.not-empty ~ label {
                            font-size: 10px;
                            font-weight: 700;
                            letter-spacing: 0.44px;
                            top: -10px;

                            &.required:after {
                                width: 5px;
                                height: 5px;
                                transform: translateY(-5px);
                            }
                        }

                        &.focus,
                        &.selected {
                            label {
                                font-size: 10px;
                                font-weight: 700;
                                letter-spacing: 0.44px;
                                top: -10px;

                                &.required:after {
                                    width: 5px;
                                    height: 5px;
                                    transform: translateY(-5px);
                                }
                            }
                        }

                        label {
                            @include label(#ffffff);
                        }

                        &.textarea {
                            margin-top: 27px;

                            label {
                                top: 23px;
                            }
                        }

                        .maxlength {
                            position: absolute;
                            right: 6px;
                            bottom: 10px;
                            color: #9ac1ff;
                            font-family: $mainFont, sans-serif;
                            font-size: 10px;
                            font-weight: 700;
                            letter-spacing: 0.44px;

                            span {
                                color: #fff;
                            }
                        }
                    }

                    button {
                        display: block;
                        width: 179px;
                        height: 38px;
                        border-radius: 19px;
                        background-color: #ffffff;
                        color: #4d4d65;
                        font-family: $mainFont, sans-serif;
                        font-size: 18px;
                        font-weight: 700;
                        letter-spacing: 0.58px;
                        margin: 85px auto 0 auto;
                        border: 0;

                        &:hover {
                            cursor: pointer;
                        }
                    }

                    .required-message {
                        text-align: center;
                        @include requiredMessage(white);
                    }
                }
            }
        }
    }
</style>
